//+------------------------------------------------------------------+
//|                                                      MTF AMA.mq4 |
//|                                          Copyright  2010, LuRAS |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "http://forum.mql4.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Yellow
//---- input parameters

extern int TimeFrame=240;

double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
//---- indicator line
  IndicatorBuffers(1);
   IndicatorShortName("AMA");
   SetIndexStyle(1,DRAW_LINE,0,2);
   SetIndexBuffer(0,ExtMapBuffer1);
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
  }

   return(0);

int start()
  {

   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();
 
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

   ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"AMA",0,y);
   }  

   return(0);
   }

